<template>
  <v-date-picker
    :title="title"
    :model-value="model"
    :color="color"
    :multiple="range ? 'range' : false"
    :disabled="disabled"
    border
    rounded="xl"
    @update:model-value="update"
  >
    <template v-if="actions" #actions>
      <slot name="actions" />
    </template>
  </v-date-picker>
</template>

<script setup>
import moment from "moment";
import { ref, watch, onMounted } from 'vue'

const emit = defineEmits(['update:modelValue'])

onMounted(() => {
  if (props?.modelValue) {
    model.value = Array.isArray(props.modelValue)
      ? props.modelValue.map((date) => (date ? moment(date).toDate() : null))
      : moment(props.modelValue).toDate();
  }
})

const model = ref(null)

const props = defineProps({
  modelValue: {
    type: undefined,
    default: null,
  },
  color: {
    type: String,
    default: 'primary',
  },
  title: {
    type: String,
    default: 'Select date',
  },
  actions: {
    type: Boolean,
    default: false,
  },
  disabled: {
    type: Boolean,
    default: false,
  },
  range: {
    type: Boolean,
    default: false,
  },
})

const update = (value) => {
  model.value = value
  emit('update:modelValue', model.value)
}

watch(props, (newValue, oldValue) => {
  if (newValue?.modelValue) {
    if (props.range) {
      model.value = newValue?.modelValue
    } else {
      model.value = new Date(newValue?.modelValue)
    }
  }
})
</script>
